﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using WSCF.RevCtrl.Test.IService;

namespace WSCF.RevCtrl.Test.Client.ServiceClient
{
    public class ChatServiceClient : RevCtrl_ServiceClient, IChatService
    {

        protected override Type InterfaceType => typeof(IChatService);

        public ChatServiceClient(string serverName, bool isByConnName, string addrOrConnName) : base(serverName, isByConnName, addrOrConnName)
        {

        }


        public int CustomerCount { get; set; }

        public CustomerInfo[] CustomerInfos { get; set; }



        public event EventHandler HavingNewMsgInGroupChat;


        public void Trigger_HavingNewMsgInGroupChat(HavingNewMsgInGroupChatEventArgs e) 
        {
            HavingNewMsgInGroupChat?.Invoke(this, e);
        }
        public void GetRecentMsgs(AsyncCBHandler asyncDelegate, object asyncContext)
        {
            Call(nameof(GetRecentMsgs), null, asyncDelegate, asyncContext);
        }

        public void SendMsgToGroupChat(string msg, AsyncCBHandler asyncDelegate, object asyncContext)
        {
            Call(nameof(SendMsgToGroupChat), new { msg }, asyncDelegate, asyncContext);
        }

        public void SendMsgToPrivateChat(string targetGuid, string msg, AsyncCBHandler asyncDelegate, object asyncContext)
        {
            Call(nameof(SendMsgToPrivateChat), new { targetGuid,msg }, asyncDelegate, asyncContext);
        }
    }
}
