﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using WSCF.RevCtrl.Test.IService;

namespace WSCF.RevCtrl.Test.Server
{
    /// <summary>
    /// MainWindow.xaml 的交互逻辑
    /// </summary>
    public partial class MainWindow : Window
    {
        WdMainVm viewModel;
        public MainWindow()
        {
            InitializeComponent();

            viewModel = new WdMainVm();

            var chat = Application.Current.Properties["chat"] as Chat;

            viewModel.Init(chat, this);

            this.DataContext = viewModel;
        }
    }
    public class WdMainVm : INotifyPropertyChanged
    {
        public event PropertyChangedEventHandler PropertyChanged;



        public ObservableCollection<string> Msgs { get; } = new ObservableCollection<string>();


        public Chat Chat => chat;
        Chat chat;
        MainWindow mainWindow;
        public void Init(Chat chat, MainWindow mainWindow) 
        {
            this.chat = chat;
            this.mainWindow = mainWindow;
            this.chat.HavingNewMsgInGroupChat += Chat_HavingNewMsgInGroupChat;
        }

        private void Chat_HavingNewMsgInGroupChat(object sender, EventArgs e)
        {
            var reponse = e as HavingNewMsgInGroupChatEventArgs;
            mainWindow.Dispatcher.Invoke(() =>
            {
                Msgs.Add(reponse.msg);
                if (Msgs.Count > 100)
                {
                    Msgs.RemoveAt(0);
                }
            });

        }
    }
}
