﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Threading;
using WSCF.Test.IService;

namespace WSCF.Test.Server
{
    public class Foo : IFooService
    {
        public int Number { get; protected set; }
        public DateTime AddFuncTime { get; protected set; }
        public string Msg { get; set; }

        public int[] Abc { get; protected set; } 

        public ProfileParam Param { get; } = new ProfileParam();
        public Bar[] Bars { get; private set; }

        public event PropertyChangedEventHandler PropertyChanged;
        public event EventHandler DataChanged;

        public DispatcherTimer timer = new DispatcherTimer();
        public Foo() 
        {
            Bars = new Bar[3];
            for (int i = 0; i < Bars.Count(); i++) {
                Bars[i] = new Bar() { Number = i*10 };
            }
            timer = new DispatcherTimer();
            timer.Interval = TimeSpan.FromSeconds(1);
            timer.Tick += Timer_Tick;
            timer.Start();
        }

        int timecnt = 0;
        private void Timer_Tick(object sender, EventArgs e)
        {
            Number++;
            List<int> abc = new List<int>();
            Random r = new Random();
            for (int i = 0; i < 3; i++) {
                abc.Add(r.Next(10));
            }
            Abc = abc.ToArray();

            timecnt++;
            if (timecnt > 3) {
                timecnt = 0;
                DataChanged?.Invoke(this, new DataChangedEventArgs()
                {

                    Time = DateTime.Now,
                    Msg = "hello " + Msg
                });


            }
        }

        public void Add(int a, int b, AsyncCBHandler asyncDelegate, object asyncContext)
        {
            Number = a + b;
            AddFuncTime = DateTime.Now;
            asyncDelegate?.Invoke(asyncContext, new FooServiceAddReponse() { result = Number });
        }

        public void Apply(ProfileParam param)
        {
            Param.PName = param.PName;
            Param.Target = param.Target;
        }
    }
}
